#include <regdef.h>
#include <asm/unistd.h>

#define Q_N	16
#define Q_M	16

.data

.text
.globl fixmath_add
.globl fixmath_mul

.type fixmath_add, @function
fixmath_add:
	# a0 and a1 have values of `a' and `b'
	addu	v0, a0, a1
	jr	ra

.type fixmath_mul, @function
fixmath_mul:
	# a0 and a1 have values of `a' and `b'
	multu	a0, a1
	mflo	t0
	mfhi	t1
	# t3 will keep previous value of LO
	move	t3, t0
	li	t2, 1
	sll	t2, t2, Q_N-1
	addu	t0, t0, t2
	sub	t3, t0, t3
	bgez	t3, 1f
	addiu	t1, 1
1:
	srl	t0, t0, 16
	sll	t1, t1, 16
	or	v0, t1, t0
	jr	ra

